/**
 * API du serveur de l'application de digitalisation des EP
 * API qui sra utilisée afin de faire communiquer le client et le serveur ainsi que le serveur et la boîte noire.
 *
 * OpenAPI spec version: 1.2.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *//* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs';

import { CollaborateurModel } from '../model/collaborateurModel';
import { ErreurModel } from '../model/erreurModel';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class CollaborateursService {

    protected basePath = 'http://localhost:3000/api';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (const consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * recevoir un collaboratuer par son id
     * @param idCollaborateur id collaborateur
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getCollaborateurById(idCollaborateur: string, observe?: 'body', reportProgress?: boolean): Observable<CollaborateurModel>;
    public getCollaborateurById(idCollaborateur: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CollaborateurModel>>;
    public getCollaborateurById(idCollaborateur: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CollaborateurModel>>;
    public getCollaborateurById(idCollaborateur: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (idCollaborateur === null || idCollaborateur === undefined) {
            throw new Error('Required parameter idCollaborateur was null or undefined when calling getCollaborateurById.');
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<CollaborateurModel>('get',`${this.basePath}/collaborateurs/${encodeURIComponent(String(idCollaborateur))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * recevoir un collaborateur par son mail
     * @param mail mail de l&#x27;utilisateur connecté (mail obetenu via Keycloak)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getCollaborateurByMail(mail: string, observe?: 'body', reportProgress?: boolean): Observable<CollaborateurModel>;
    public getCollaborateurByMail(mail: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CollaborateurModel>>;
    public getCollaborateurByMail(mail: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CollaborateurModel>>;
    public getCollaborateurByMail(mail: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (mail === null || mail === undefined) {
            throw new Error('Required parameter mail was null or undefined when calling getCollaborateurByMail.');
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<CollaborateurModel>('get',`${this.basePath}/collaborateurs/${encodeURIComponent(String(mail))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * recevoir la liste des collaborateurs
     * @param assistants paramètre pour indiquer explicitement que l&#x27;on souhaite récupérer les assistants dans la requête
     * @param collaborateurs paramètre pour indiquer explicitement que l&#x27;on souhaite récupérer les collaborateurs dans la requête
     * @param idBu id de la business unit à laquelle sont rattachées les données à récupérer
     * @param idAgence id de l&#x27;agence à laquelle sont rattachées les données à récupérer
     * @param referents paramètre pour indiquer explicitement que l&#x27;on souhaite récupérer les référents dans la requête
     * @param rh paramètre pour indiquer explicitement que l&#x27;on souhaite récupérer les RH dans la requête
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getCollaborateurs(assistants?: boolean, collaborateurs?: boolean, idBu?: number, idAgence?: number, referents?: boolean, rh?: boolean, observe?: 'body', reportProgress?: boolean): Observable<Array<CollaborateurModel>>;
    public getCollaborateurs(assistants?: boolean, collaborateurs?: boolean, idBu?: number, idAgence?: number, referents?: boolean, rh?: boolean, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<CollaborateurModel>>>;
    public getCollaborateurs(assistants?: boolean, collaborateurs?: boolean, idBu?: number, idAgence?: number, referents?: boolean, rh?: boolean, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<CollaborateurModel>>>;
    public getCollaborateurs(assistants?: boolean, collaborateurs?: boolean, idBu?: number, idAgence?: number, referents?: boolean, rh?: boolean, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {







        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (assistants !== undefined && assistants !== null) {
            queryParameters = queryParameters.set('assistants', <any>assistants);
        }
        if (collaborateurs !== undefined && collaborateurs !== null) {
            queryParameters = queryParameters.set('collaborateurs', <any>collaborateurs);
        }
        if (idBu !== undefined && idBu !== null) {
            queryParameters = queryParameters.set('idBu', <any>idBu);
        }
        if (idAgence !== undefined && idAgence !== null) {
            queryParameters = queryParameters.set('idAgence', <any>idAgence);
        }
        if (referents !== undefined && referents !== null) {
            queryParameters = queryParameters.set('referents', <any>referents);
        }
        if (rh !== undefined && rh !== null) {
            queryParameters = queryParameters.set('rh', <any>rh);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<CollaborateurModel>>('get',`${this.basePath}/collaborateurs`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Recevoir la liste des collaborateurs de le référent à la charge
     * @param idReferent id referent
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getCollaborateursByReferent(idReferent: string, observe?: 'body', reportProgress?: boolean): Observable<CollaborateurModel>;
    public getCollaborateursByReferent(idReferent: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CollaborateurModel>>;
    public getCollaborateursByReferent(idReferent: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CollaborateurModel>>;
    public getCollaborateursByReferent(idReferent: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (idReferent === null || idReferent === undefined) {
            throw new Error('Required parameter idReferent was null or undefined when calling getCollaborateursByReferent.');
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<CollaborateurModel>('get',`${this.basePath}/collaborateurs/referent/${encodeURIComponent(String(idReferent))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
